#!/usr/bin/env bash

################################################################################################
# NOTE: `chmod +x test.sh` vorher ausführen, um dieses Skript benutzen zu können.
################################################################################################

################################
# HILFSMETHODEN
################################

function call_go() {
    go $@;
}

function check_requirements() {
    [ -f "go.sum" ] && rm "go.sum";
    call_go get "$( cat requirements )";
}

function run_unittests(){
    echo -e "\033[1mUNITTESTS\033[0m\n";
    call_go test -v -timeout 60s -count 1 -run "^Test[A-Z].*" "logik" "./...";
}

################################
# HAUPTVORGÄNGE
################################

# Kann auskommentiert werden, wenn nötige Module schon installiert:
check_requirements;

# Code testen (unittests):
run_unittests;
